#ifndef _SLIST_HPP_
#define _SLIST_HPP_
#include <string.h>
#include <alloc.h>
#include "common.hpp"

#define INITIAL_SIZE 1
#define STEP 1

class SList
{
 private:
  u8 **buf;
  size_t bufSize;
  size_t noElems;
  void allocBuf(void)
  {
   buf = (u8**)malloc(INITIAL_SIZE*sizeof(u8*));
   bufSize = INITIAL_SIZE;
   noElems = 0;
  }
  void freeBuf(void)
  {
   for(int i = 0; i < noElems; i++) delete[] buf[i];
   free(buf);
  }

 public:
  SList(void) { allocBuf(); }
  ~SList(void) { freeBuf(); }
  void removeAll(void) { freeBuf(); allocBuf(); }
  void add(u8 *ptr)
  {
   if(noElems == bufSize)
   {
    buf = (u8**)realloc(buf, (bufSize+STEP)*sizeof(u8*));
    bufSize += STEP;
   }
   buf[noElems++] = strcpy(new u8[strlen(ptr)+1], ptr);
  }
  u8* operator[](size_t pos) { return buf[pos]; }
  size_t size(void) { return noElems; }
};

#endif